aboutsummaryrefslogtreecommitdiff
path: root/tools/test/stress2/misc/union.sh
diff options
context:
space:
mode:
authorPeter Holm <pho@FreeBSD.org>2021-03-03 12:56:56 +0000
committerPeter Holm <pho@FreeBSD.org>2021-03-03 14:11:40 +0000
commit8a272653d9fbd9fc37691c9aad6a05089b4ecb4d (patch)
tree2463ed22a342700cb7ba2b05c3d5370f75090899 /tools/test/stress2/misc/union.sh
parent3adf72a36b9b151eef57e3d83f71a3a9fbacb78d (diff)
downloadsrc-8a272653d9fbd9fc37691c9aad6a05089b4ecb4d.tar.gz
src-8a272653d9fbd9fc37691c9aad6a05089b4ecb4d.zip
stress2: Initial import
Discussed with: kib
Diffstat (limited to 'tools/test/stress2/misc/union.sh')
-rwxr-xr-xtools/test/stress2/misc/union.sh65
1 files changed, 65 insertions, 0 deletions
diff --git a/tools/test/stress2/misc/union.sh b/tools/test/stress2/misc/union.sh
new file mode 100755
index 000000000000..cef2e4c69868
--- /dev/null
+++ b/tools/test/stress2/misc/union.sh
@@ -0,0 +1,65 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2009 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+
+# Simple union test scenario
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+u1=$mdstart
+u2=$((u1 + 1))
+
+mount | grep -q /dev/md${u2}$part && umount -f /dev/md${u2}$part
+mount | grep -q /dev/md${u1}$part && umount -f /dev/md${u1}$part
+mdconfig -l | grep -q md$u2 && mdconfig -d -u $u2
+mdconfig -l | grep -q md$u1 && mdconfig -d -u $u1
+
+mdconfig -s 256m -u $u1
+bsdlabel -w md$u1 auto
+newfs md${u1}$part > /dev/null
+
+mdconfig -s 256m -u $u2
+bsdlabel -w md$u2 auto
+newfs md${u2}$part > /dev/null
+
+mount -o ro /dev/md${u1}$part $mntpoint
+mount -o union /dev/md${u2}$part $mntpoint
+
+export RUNDIR=$mntpoint/stressX
+export runRUNTIME=10m
+(cd ..; ./run.sh marcus.cfg) > /dev/null
+
+umount /dev/md${u2}$part
+umount /dev/md${u1}$part
+
+mount | grep -q /dev/md${u2}$part && umount -f /dev/md${u2}$part
+mount | grep -q /dev/md${u1}$part && umount -f /dev/md${u1}$part
+
+mdconfig -d -u $u2
+mdconfig -d -u $u1